function [snr_direct,Cs2,VSST_s]= Fig_recons_old(cas)
 N = 1024;

 % Parameters
 gamma = 0.01;
 index = N/8+1:7*N/8;
 clwin = 10;
 lambda = 0;
 beta   = 0;

 t = (0:N-1)/N;
 sigma = 0.01:0.01:0.2;
 
 %% Tests signals 1
 if (cas == 1)
  a  = 2;%exp(-8*(t-0.5).^2);
  s1 = a.*exp(2*pi*1i*(250*t+50*t.^3));
  s2 = a.*exp(2*pi*1i*(130*t+100*t.^2));
  s3 = a.*exp(2*pi*1i*(90*t+0.2*cos(3*pi*t)));
  s  = s1+s2+s3;
  nr = 3;
 else
 %% Test signal 2
  a  = 2;%exp(-8*(t-0.5).^2);
  s1 = a.*exp(2*pi*1i*(330*t+16*cos(3*pi*t)));
  s2 = a.*exp(2*pi*1i*(190*t+9*cos(3*pi*t)));
  s3 = a.*exp(2*pi*1i*(40*t));
  s  = s1+s2+s3;
  nr = 3;
 end

 %% computation of the optimal sigma
%  En = 0;
%  for p = 1:length(sigma)
%   [STFT,SST,VSST_s] = sst2_new(s,1/sigma(p)^2/N,N,gamma);
%   E = calcul_Energy(VSST_s,nr);
%   if (E > En)
%    En = E;
%    p_opt = p;
%   end 
%  end

 %sigma_opt = sigma(p_opt);
 sigma_opt = 0.04;
 %%computation of transforms with different frequency resolutions 
 Nfft1 = N;
 [STFT,SST,VSST_s] = sst2(s,sigma_opt,Nfft1,gamma);
 Nfft2 = 2*N;
 [STFT1,SST1,VSST1_s] = sst2(s,sigma_opt,Nfft2,gamma);
 Nfft3 = 4*N;
 [STFT2,SST2,VSST2_s] = sst2(s,sigma_opt,Nfft3,gamma);
 Nfft4 = 8*N;
 [STFT3,SST3,VSST3_s] = sst2(s,sigma_opt,Nfft4,gamma);
 Nfft5 = 16*N;
 [STFT4,SST4,VSST4_s] = sst2(s,sigma_opt,Nfft5,gamma);

 %%computation of demodulated signals+instantaneous frequencies

 [sd_1,sd_2,sd_3,sd_4,sd_5,integ1,integ2,integ3,integ4,integ5] = ...
 demod_mult(s,VSST_s,VSST1_s,VSST2_s,VSST3_s,VSST4_s,Nfft1,Nfft2,Nfft3,Nfft4,Nfft5,t,N,nr);   

 %%computation of the ridges for direct reconstruction
 [Cs2, Es] = exridge_mult(VSST_s,nr,lambda,beta,clwin);
 [Cs21,Es] = exridge_mult(VSST1_s,nr,lambda,beta,clwin);
 [Cs22,Es] = exridge_mult(VSST2_s,nr,lambda,beta,clwin);
 [Cs23,Es] = exridge_mult(VSST3_s,nr,lambda,beta,clwin);
 [Cs24,Es] = exridge_mult(VSST4_s,nr,lambda,beta,clwin);

 %%signal reconstruction

 snr_direct = zeros(5,nr,3);%first index for Nfft, second index for d
 %snr_demod  = zeros(5,nr,3);

 d = 0:5:10;
 signal = [s1;s2;s3];
 sign1 = zeros(nr,length(s));
 sign2 = zeros(nr,length(s));
 sign3 = zeros(nr,length(s));
 sign4 = zeros(nr,length(s));
 sign5 = zeros(nr,length(s));
 
 for  k = 1:length(d), %qq realizations ofthe noise
  k
  for p = 1:nr,
   sign1(p,:) = sigma_opt*recmodes(VSST_s,Cs2(p,:),d(k));
   sign2(p,:) = sigma_opt*Nfft1/Nfft2*recmodes(VSST1_s,Cs21(p,:),2*d(k));
   sign3(p,:) = sigma_opt*Nfft1/Nfft3*recmodes(VSST2_s,Cs22(p,:),4*d(k));
   sign4(p,:) = sigma_opt*Nfft1/Nfft4*recmodes(VSST3_s,Cs23(p,:),8*d(k));
   sign5(p,:) = sigma_opt*Nfft1/Nfft5*recmodes(VSST4_s,Cs24(p,:),16*d(k));
   
   
   snr_direct(:,p,k) =  [snr(signal(p,index),sign1(p,index)-signal(p,index))...
                         snr(signal(p,index),sign2(p,index)-signal(p,index))...
                         snr(signal(p,index),sign3(p,index)-signal(p,index))...
                         snr(signal(p,index),sign4(p,index)-signal(p,index))...
                         snr(signal(p,index),sign5(p,index)-signal(p,index))];
  end
 end
end
 
%  %reconstruction using smooth ridges determined from VSST and smoothed with EMD,
%    %and then demodulation 
%    imf_demod = zeros(nr,N);
%    imf_demod_noopt = zeros(nr,N);%with no optimization on sigma
%    
%    for q = 1:nr,
%     [indmin,indmax,indzer] = extrbis(Cs(q,:)-1);
%     if (length(indmin)>=2) && (length(indmax)>=2)
%      [imf]   = emdbis(Cs(q,:)-1);
%      R_vsst  = Cs(q,:)-1-imf(1,:);
%     else
%      R_vsst  = Cs(q,:)-1;  
%     end
%     
%     %numerical integration of Y, and demodulation
%     integ = cumtrapz(t,R_vsst);
%     sp = s0.*exp(-2*1i*pi*(integ-100.*t));
%     
%     for j = 1:length(sigma)
%      [STFT,SST,VSST,omega,tau,omega2] = sst2(sp,gamma,sigma(j),ft,bt);
%      Ren(j) =renyi_entropy(abs(VSST),t,f',3);
%     end
%     
%     %optimal sigma
%     sigma_opt_demod = sigma(Ren == min(Ren));
%     %perform the sunchrosqueezing transform on the demodulated modes using the optimized sigma 
%     [STFT1,SST1,VSST1,omega,tau,omega2] = sst2(sp,gamma,sigma_opt_demod,ft,bt);
%     %we extract q ridges
%     [C, Es] = exridge_mult(SST1,q,lambda,beta,clwin);
%    
%     %reconstruction of mode k, using the SST
%     imf2 = sigma_opt_demod*recmodes(SST1,C(q,:),d);
%     imf2 = imf2.*exp(2*1i*pi*(integ-100.*t));
%     imf_demod(q,:) = imf2; 
%    
%     %perform the synchrosqueezing transform on the demodulated modes with
%     %no optimization on sigma
%     [STFT1,SST1,VSST1,omega,tau,omega2] = sst2(sp,gamma,sigma_optR1,ft,bt);
%     %we extract q ridges
%     [C1, Es] = exridge_mult(SST1,q,lambda,beta,clwin);
%    
%     %reconstruction of mode k, using the SST
%     imf2 = sigma_optR1*recmodes(SST1,C1(q,:),d);
%     imf2 = imf2.*exp(2*1i*pi*(integ-100.*t));
%     imf_demod_noopt(q,:) = imf2; 
%    end
%   
%    if (cas == 1)
%     snr_demod(k,:) = [snr(s1(index),imf_demod(1,index)-s1(index)) ...
%                      snr(s2(index),imf_demod(2,index)-s2(index)) ...
%                      snr(s3(index),imf_demod(3,index)-s3(index))];
%     snr_demod_noopt(k,:) = [snr(s1(index),imf_demod_noopt(1,index)-s1(index)) ...
%                      snr(s2(index),imf_demod_noopt(2,index)-s2(index)) ...
%                      snr(s3(index),imf_demod_noopt(3,index)-s3(index))];
% 
%    else
%     snr_demod(k,:) = [snr(s1(index),imf_demod(1,index)-s1(index)) ...
%                      snr(s2(index),imf_demod(2,index)-s2(index))];
%     snr_demod_noopt(k,:) = [snr(s1(index),imf_demod_noopt(1,index)-s1(index)) ...
%                            snr(s2(index),imf_demod_noopt(2,index)-s2(index))];
%    end    
%  end
%  if (qq==1),
%   if (cas == 1)
%    snr_1_demod = snr_demod(:,1);
%    snr_2_demod = snr_demod(:,2);
%    snr_3_demod = snr_demod(:,3);
%    snr_1_demod_noopt = snr_demod_noopt(:,1);
%    snr_2_demod_noopt = snr_demod_noopt(:,2);
%    snr_3_demod_noopt = snr_demod_noopt(:,3);
%    snr_1_direct = snr_direct(:,1);
%    snr_2_direct = snr_direct(:,2);
%    snr_3_direct = snr_direct(:,3);
%   else
%    snr_1_demod = snr_demod(:,1);
%    snr_2_demod = snr_demod(:,2);
%    snr_1_demod_noopt = snr_demod_noopt(:,1);
%    snr_2_demod_noopt = snr_demod_noopt(:,2);
%    snr_1_direct = snr_direct(:,1);
%    snr_2_direct = snr_direct(:,2);
%   end
%  else
%   if (cas == 1)
%    snr_1_demod = [snr_1_demod snr_demod(:,1)];
%    snr_2_demod = [snr_2_demod snr_demod(:,2)];
%    snr_3_demod = [snr_3_demod snr_demod(:,3)];
%    snr_1_demod_noopt = [snr_1_demod_noopt snr_demod(:,1)];
%    snr_2_demod_noopt = [snr_2_demod_noopt snr_demod(:,2)];
%    snr_3_demod_noopt = [snr_3_demod_noopt snr_demod(:,3)];
%    snr_1_direct = [snr_1_direct snr_direct(:,1)];
%    snr_2_direct = [snr_2_direct snr_direct(:,2)];
%    snr_3_direct = [snr_3_direct snr_direct(:,3)];
% 
%   else
%    snr_1_demod = [snr_1_demod snr_demod(:,1)];
%    snr_2_demod = [snr_2_demod snr_demod(:,2)];
%    snr_1_demod_noopt = [snr_1_demod_noopt snr_demod(:,1)];
%    snr_2_demod_noopt = [snr_2_demod_noopt snr_demod(:,2)];
%    snr_1_direct = [snr_1_direct snr_direct(:,1)];
%    snr_2_direct = [snr_2_direct snr_direct(:,2)];
%   end
%  end
% end 
%  if cas == 2
%   snr_3_demod = 0;
%   snr_3_demod_noopt = 0;
%   snr_3_direct = 0;
%  end 
% end
 