

%% Signal
N = 1024;
t = (0:N-1)/N;

a  = 2; 
s1 = a.*exp(2*pi*1i*(250*t+100*t.^3));
s2 = a.*exp(2*pi*1i*(130*t+100*t.^2));
s3 = a.*exp(2*pi*1i*(90*t+0.2*cos(3*pi*t)));

%% Parameters
gamma = 0.01;
sigma = 0.04;

% Choice of time and frequency bins
ft = 1:N/2;
bt = 1:N;

% reconstruction parameters
lambda = 0.2;
beta   = 0.1;

%% Compute TF transforms
for p = 1:3,
 if (p == 1)
  s = s1;
 end
 if (p == 2)
  s = s2;
 end
 if (p == 3)
  s = s3;
 end
 
 [STFT,SST,VSST,omega,tau,omega2] = sst2(s,gamma,sigma,ft,bt);
 
 %Figure A B C
 t  = (0:N-1)/N;
 fs = (0:N/2-1);
 imagesc(t,fs,abs(VSST));
 set(gca,'YDir','normal')
 colormap(1-gray)
 pause
 
 [Cs, Es] = exridge(VSST,lambda,beta);
 [indmin,indmax,indzer] = extrbis(Cs-1);
 if (length(indmin)>=2)&&(length(indmax)>=2)
  [imf]   = emdbis(Cs-1);
  R_vsst  = Cs-1-imf(1,:);
 else
  R_vsst  = Cs-1;  
 end 
 
 %integration of the IF estimate 
 integ = cumtrapz(t,R_vsst);
 sp = s.*exp(-2*1i*pi*(integ-100.*t));
 %perform the sunchrosqueezing transform on the demodulated modes 
 
 [STFT1,SST1,VSST1,omega,tau,omega2] = sst2(sp,gamma,sigma,ft,bt);
 
 %Figure D E F
 imagesc(t,fs,abs(VSST1));
 set(gca,'YDir','normal')
 colormap(1-gray)
 pause
end
 

