function [snr_demod,snr_direct,Ren,Sha] =fig8_New(cas)

%% Signal
%N = 2048;
N = 1024;
t = (0:N-1)/N;

%test signal 1
if (cas == 2)
 %test signal 1
 s1 = exp(2*pi*1i*(330*t+16*cos(3*pi*t)));
 s2 = exp(2*pi*1i*(190*t+9*cos(3*pi*t)));
 %s3 = exp(2*pi*1i*(40*t));
 s  = s1+s2;%+s3;
else
 %test signal 2
 a  = 2;
 s1 = a.*exp(2*pi*1i*(250*t+100*t.^3));
 s2 = a.*exp(2*pi*1i*(130*t+100*t.^2));
 s3 = a.*exp(2*pi*1i*(90*t+0.2*cos(3*pi*t)));%low frequency component
 s  = s1+s2+s3;
end

%% Parameters
gamma = 0.01;
if cas == 1
  nr = 3;
 else
  nr = 2;
 end
snr_direct = zeros(20,nr);
snr_demod  = zeros(20,nr);

sigma = 0.01:0.01:0.2;

% Choice of time and frequency bins
ft = 1:N/2;
bt = 1:N; 

% reconstruction parameters
clwin = 10;
lambda = 0; %no regularization
beta  =  0;
d = 0;

%we only consider the inner part
index = N/8+1:7*N/8;
Ren = zeros(1,length(sigma));
Sha = zeros(1,length(sigma));

for p = 1:20,
 p
 %% Compute TF transforms
 [STFT,SST,VSST,omega,tau,omega2] = sst2(s,gamma,sigma(p),ft,bt);
 fs = 0:N/2-1;
 %imagesc(t,fs,abs(VSST));
 %set(gca,'YDir','normal')
 %colormap(1-gray)
 %pause
 Ren(p) =renyi_entropy(abs(VSST),t,fs',3);
 Sha(p) =renyi_entropy(abs(VSST),t,fs',1);

 [Cs, Es] = exridge_mult(VSST,nr,lambda,beta,clwin);
 
 %direct reconstruction using ridges determined from VSST  
 imf_direct = sigma(p)*recmodes(VSST,Cs,d);
 if (cas == 1)
  snr_direct(p,:) =  [snr(s1(index),imf_direct(1,index)-s1(index))... 
                     snr(s2(index),imf_direct(2,index)-s2(index))...
                     snr(s3(index),imf_direct(3,index)-s3(index))];
 else
  snr_direct(p,:) =  [snr(s1(index),imf_direct(1,index)-s1(index))... 
                      snr(s2(index),imf_direct(2,index)-s2(index))];
 end
  
 %reconstruction using smooth ridges determined from VSST and smoothed with EMD,
 %and then demodulation 
 imf_demod = zeros(nr,N);
 
 for k = 1:nr,
  [indmin,indmax,indzer] = extrbis(Cs(k,:)-1);
  if (length(indmin)>=2)&&(length(indmax)>=2)
   [imf]   = emdbis(Cs(k,:)-1);
   R_vsst  = Cs(k,:)-1-imf(1,:);
  else
   R_vsst  = Cs(k,:)-1;  
  end
  %numerical integration of Y, and demodulation
  integ = cumtrapz(t,R_vsst);
  sp = s.*exp(-2*1i*pi*(integ-100.*t));
 
  %perform the sunchrosqueezing transform on the demodulated modes 
  [STFT1,SST1,VSST1,omega,tau,omega2] = sst2(sp,gamma,sigma(p),ft,bt);
  % fs = 0:N/2-1;
  %imagesc(t,fs,abs(VSST1));
  %set(gca,'YDir','normal')
  % colormap(1-gray)
  % pause
  %we extract k ridges
  [C, Es] = exridge_mult(VSST1,k,lambda,beta,clwin);
  
  %reconstruction of mode k, using the SST
  imf2 = sigma(p)*recmodes(SST1,C(k,:),d);
  imf2 = imf2.*exp(2*1i*pi*(integ-100.*t));
  imf_demod(k,:) = imf2;
  
 end
 
 if (cas == 1)
  snr_demod(p,:) = [snr(s1(index),imf_demod(1,index)-s1(index)) ...
                    snr(s2(index),imf_demod(2,index)-s2(index)) ...
                    snr(s3(index),imf_demod(3,index)-s3(index))];
 else
   snr_demod(p,:) = [snr(s1(index),imf_demod(1,index)-s1(index)) ...
                     snr(s2(index),imf_demod(2,index)-s2(index))];
 end    
end
clear figure
plot(sigma,snr_demod(:,1),sigma,snr_direct(:,1),'--');%high frequency mode
figure
plot(sigma,snr_demod(:,2),sigma,snr_direct(:,2),'--');
if cas == 1
 figure   
 plot(sigma,snr_demod(:,3),sigma,snr_direct(:,3),'--');
end