function test_demod (cas)

%% Signal
N = 2048;
%N = 1024;
t = (0:N-1)/N;

if (cas == 1)
 %test signal 1
 %a  = exp(-8*(t-0.5).^2);
 s1 = exp(2*pi*1i*(330*t+16*cos(3*pi*t)));
 s2 = exp(2*pi*1i*(190*t+9*cos(3*pi*t)));
 s3 = exp(2*pi*1i*(40*t));
 s  = s1+s2+s3;
elseif cas == 2
 %test signal 2
 a  = exp(-8*(t-0.5).^2);
 s1 = a.*exp(2*pi*1i*(250*t+100*t.^3));
 s2 = a.*exp(2*pi*1i*(130*t+100*t.^2));
 s3 = a.*exp(2*pi*1i*(90*t+0.2*cos(3*pi*t)));%low frequency component
 s  = s1+s2+s3;
else 
 load -ascii batsig.txt
 s = batsig;
 s = s';
 gamma = 0.00001;
 N = length(s);
 t = (0:N-1)/N;
 %[imf]=emdbis(s);
 %s1 = imf(1,:)+imf(2,:)+imf(3,:);%we 've got everything in the first 3 IMF.
 %plot(t,s,t,s1,'--')
 %ft =1:N/2;
 %bt=1:N;
 %[STFT,SST,RSTFT,OSST,VSST,GAR,omega,tau,omega2] = sst2_new(imf(1,:),1,gamma,0.04,ft,bt);
 %fs = (0:N/2);
 % imagesc(t,fs,abs(VSST));
 % set(gca,'YDir','normal')
 % colormap(1-gray)
 %pause
 %[STFT,SST,RSTFT,OSST,VSST,GAR,omega,tau,omega2] = sst2_new(imf(2,:),1,gamma,0.04,ft,bt);
 %fs = (0:N/2);
 % figure
 % imagesc(t,fs,abs(VSST));
 % set(gca,'YDir','normal')
 % colormap(1-gray)
 %pause
 %[STFT,SST,RSTFT,OSST,VSST,GAR,omega,tau,omega2] = sst2_new(imf(3,:),1,gamma,0.04,ft,bt);
 %fs = (0:N/2);
 % figure
 % imagesc(t,fs,abs(VSST));
 % set(gca,'YDir','normal')
 % colormap(1-gray)
 %pause

 %s = s- mean(s);%we consider a null average signal
end

%% Parameters
if cas <= 2
 gamma = 0.001;
end

if (cas <= 2)
 snr_direct = zeros(10,3);
 snr_demod  = zeros(10,3);
 snr_demod_1  = zeros(10,3);
else
 snr_direct = zeros(1,10);
 snr_demod  = zeros(1,10);
 snr_demod_1  = zeros(1,10);
end

sigma = 0.01:0.01:0.1;
% Choice of time and frequency bins
ft =1:N/2;
bt=1:N;
% reconstruction parameters
clwin = 10;
lambda = 0.02;
if (cas <= 2)
 d = 0;
else 
 d = 10;
end
%we only consider the inner part
if (cas <= 2)
 index = N/8+1:7*N/8;
else
 index = N/4+1:3*N/4;  
end

for p = 1:10,
 p
 %% Compute TF transforms
 [STFT,SST,RSTFT,OSST,VSST,GAR,omega,tau,omega2] = sst2_new(s,1,gamma,sigma(p),ft,bt);
 fs = (0:N/2);
 if (p == 4)
  imagesc(t,fs,abs(VSST));
  set(gca,'YDir','normal')
  colormap(1-gray)
  hold on;
 end
 %ridge extraction on VSST
 %if (cas <= 2)
  nr = 3;
 %else
 % nr = 4;
 %end
 
 [Cs, Es] = exridge_mult_Noise(VSST,nr,lambda, clwin);
 if p == 4
  plot(t,Cs(1,:)-1,t,Cs(2,:)-1,'--',t,Cs(3,:)-1,'-.');
  hold off;
  pause
 end
 %direct reconstruction using VSST, the modes are complex  
 imf_direct = recmodes(VSST,Cs,d);
 if (cas <= 2)
  snr_direct(p,:) =  [snr(s1(index),imf_direct(1,index)-s1(index)) snr(s2(index),imf_direct(2,index)-s2(index)) ...
                      snr(s3(index),imf_direct(3,index)-s3(index))];
 else
  snr_direct(p) =  snr(s(index),imf_direct(1,index)+imf_direct(2,index)+imf_direct(3,index));%+imf_direct(4,index)+imf_direct(5,index)-s(index)); 
  if (p == 4)
   plot(t(index),real(s(index)),t(index),...
       real(imf_direct(1,index)+imf_direct(2,index)+imf_direct(3,index)),'--')
   pause 
  end
 end
 
 for k = 1:nr,
  %we perform demodulation only when the modulation is high enough
  cas1 = 0;
  if (max(abs(diff(Cs(k,index))))*N > 10^(-1))
   [imf]=emdbis(Cs(k,:)-1);
   x  = Cs(k,:)-1-imf(1,:);
   %plot(Cs(k,:)-1,'--')
   %pause
   %Adeb = [3*t(200)^2 2*t(200) 1;3*t(300)^2 2*t(300) 1;3*t(400)^2 2*t(400) 1];
   %Cdeb = inv(Adeb)*[x(200);x(300);x(400)];
   %Afin = [3*t(N-200)^2 2*t(N-200) 1;3*t(N-300)^2 2*t(N-300) 1;3*t(N-400)^2 2*(N-400) 1];
   %Cfin = inv(Afin)*[x(N-200);x(N-300);x(N-400)];
   %Y    = [ 3*Cdeb(1)*(t(1:199).^2)+2*Cdeb(2)*t(1:199)+Cdeb(3) x(200:N-200) ...
   %       3*Cfin(1)*(t(N-199:N).^2)+2*Cfin(2)*t(N-199:N)+Cfin(3)];
   %numerical integration of Y
   integ = cumtrapz(t,x);
   sp = s.*exp(-2*1i*pi*(integ-100.*t));
   %perform the synchrosqueezing transform on the demodulated modes 
   [STFT1,SST1,RSTFT1,OSST1,VSST1,GAR1,omega,tau,omega2] = sst2_new(sp,1,gamma,sigma(p),ft,bt);
   cas1 = 1;
  else
   [STFT1,SST1,RSTFT1,OSST1,VSST1,GAR1,omega,tau,omega2] = sst2_new(s,1,gamma,sigma(p),ft,bt);   
  end
  cas
  %we extract k ridges, reconstruction from SST
  %imagesc(t,fs,abs(VSST1));
  %set(gca,'YDir','normal')
  %colormap(1-gray)
  %pause

  if (cas <= 2)
   [C, Es] = exridge_mult_Noise(SST1,k,lambda,clwin);  
   imf1 = recmodes(SST1,C(k,:),d);
  else
   %we know that the mode of interest is around 100   
   imf1 = recmodes(SST1,100*ones(1,N),d);
  end
  
  if (cas1 == 1)
   imf1 = imf1.*exp(2*1i*pi*(integ-100.*t));
  end
  %we extract k ridges, reconstruction from VSST
  if (cas <= 2)
   [C, Es] = exridge_mult_Noise(VSST1,k,lambda,clwin);
   imf2 = recmodes(VSST1,C(k,:),d);
  else
   %we know that the mode of interest is around 100   
   imf2 = recmodes(VSST1,100*ones(1,N),d);  
  end
  
  if (cas1 == 1)
   imf2 = imf2.*exp(2*1i*pi*(integ-100.*t));
  end
  
  if (cas <= 2)
   if (k == 1),
    snr_int   = snr(s1(index),imf1(index)-s1(index)); 
    snr_int_1 = snr(s1(index),imf2(index)-s1(index));
   elseif (k == 2)
    snr_int   = [snr_int snr(s2(index),imf1(index)-s2(index))];
    snr_int_1 = [snr_int_1 snr(s2(index),imf2(index)-s2(index))];
   else 
    snr_int   = [snr_int snr(s3(index),imf1(index)-s3(index))];
    snr_int_1 = [snr_int_1 snr(s3(index),imf1(index)-s3(index))];
   end
  else
   if (k == 1)
    mode  = imf1(index);
    mode1 = imf2(index);
   elseif (k == 2)
    mode  = [mode ; imf1(index)];
    mode1 = [mode1 ; imf2(index)];
   else
    mode  = [mode ; imf1(index)];
    mode1 = [mode1 ; imf2(index)];
    %plot(t(index),s(index),t(index),real(sum(mode)),'--')
    %pause
    snr_int   = snr(s(index),sum(mode)-s(index));
    snr_int_1 = snr(s(index),sum(mode1)-s(index));
   end
  end
 end
 
 if (cas <= 2)
  snr_demod(p,:)   = snr_int;
  snr_demod_1(p,:) = snr_int_1;
 else
  snr_demod(p)   = snr_int;
  snr_demod_1(p) = snr_int_1;  
 end
end
if (cas <= 2)
 plot(sigma,snr_demod(:,1),sigma,snr_demod_1(:,1),'-.',sigma,snr_direct(:,1),'--');%high frequency mode
 figure
 plot(sigma,snr_demod(:,2),sigma,snr_demod_1(:,2),'-.',sigma,snr_direct(:,2),'--');
 figure
 plot(sigma,snr_demod(:,3),sigma,snr_demod_1(:,3),'-.',sigma,snr_direct(:,3),'--');
else
 plot(sigma,snr_demod,sigma,snr_demod_1,'-.',sigma,snr_direct,'--');  
end
end
