function test_renyi_multi_mode_noise()
clc; 
clear all; 
close all;

%set(0,'DefaultAxesFontSize',15);

N = 1024;
fs = 0:N/2;
T=1;

% Parameters
gamma = 0;
%sigma = 0.05;
sigma = [0.001:0.01:0.3];
index = N/8+1:7*N/8;
d = 10;
clwin = 10;
lambda = 0.02;
nmodes = 3;

t = (0:N-1)/N;f = 0:N/2-1; 

% Choice of time and frequency bins
ft =1:N/2;bt=1:N;

%% Tests signals 1
a = exp(-8*(t-0.5).^2);
s1 = a.*sin(2*pi*(250*t+100*t.^3));
s2 = a.*sin(2*pi*(130*t+100*t.^2));
s3 = a.*sin(2*pi*(90*t+0.2*cos(3*pi*t)));
%s = s1+s2+s3;

%% Test signal 2
%a = exp(-8*(t-0.5).^2);
%s1 = a.*sin(2*pi*(330*t+16*cos(3*pi*t)));
%s2 = a.*sin(2*pi*(190*t+9*cos(3*pi*t)));
%s3 = a.*sin(2*pi*(40*t));

%% Test signal with noise
s = s1+s2+s3;
%Generate Gaussian Noise with zeros mean and a standard deviation
mean = 0;
std_noise = 0.07;% noise standard deviation
noise=std_noise*randn(1,length(s))+mean;
%s=s+noise;

% Generate white Gaussian noise with a SNR 
s1=awgn(s1,10,'measured'); % Add white Gaussian noise
s2=awgn(s2,8,'measured');
s3=awgn(s3,15,'measured');
s = s1+s2+s3;

%s=s/norm(s,2)*sqrt(length(s));


%% display ts1
figure();
subplot(3,1,1);
plot(t,s1,'b');
ylabel('Mode 1');set(gca,'xtick',[]);xlim([.1 .9]);
subplot(3,1,2);
plot(t,s2,'g');
ylabel('Mode 2');set(gca,'xtick',[]);xlim([.1 .9]);
subplot(3,1,3);
plot(t,s3,'r');
ylabel('Mode 3');xlabel('t');xlim([.1 .9]);

%% Iteration for different sigma valeurs

Ren = zeros(length(sigma),1);
Sha = zeros(length(sigma),1);
for j = 1:length(sigma)
% SST
[STFT, SST, RSTFT, OSST, VSST, GAR, omega, tau, omega2] = sst2_new(s,T,gamma,sigma(j),ft,bt);
Ren(j) =renyi_entropy(abs(VSST),t,f',3);
Sha(j) =renyi_entropy(abs(VSST),t,f',1);
end

sigma_optR = sigma(Ren==min(Ren))
sigma_optS = sigma(Sha==min(Sha))

% Display the concentration measure!! 
figure();
plot(sigma,Ren,'b',sigma,Sha,'--r');
hold on;
plot(sigma_optR,min(Ren),'r*',sigma_optS,min(Sha),'o');

legend('Renyi entropy','Shanon entropy','Location','northoutside','Orientation','horizontal');
strmin = [' \leftarrow Renyi_{min}=' num2str(min(Ren)) ' & \sigma_{opt} = ' num2str(min(sigma_optR))];
text(sigma_optR,min(Ren)-0.2,strmin,'HorizontalAlignment','left');

ylabel('Concentration measure');
xlabel('\sigma');
%title('Standard SST of signal 1')
grid on;
explot();
set(findall(0,'type','Line'),'LineWidth',2);
%pause;


%% Reconstruction st1

% SST
[STFT SST RSTFT OSST VSST GAR omega tau omega2] = sst2_new(s,T,gamma,sigma_optR,ft,bt);

% Display TFRs
figure();
imagesc(t,fs,abs(STFT));title('STFT');
set(gca,'YDir','normal')
xlabel('t');
ylabel('\eta');
colormap(1-gray);
%pause;
%close;

figure();
imagesc(t,fs,abs(SST));title('SST');
set(gca,'YDir','normal','xtick',[],'ytick',[]);
colormap(1-gray);
%pause;
%close;

figure();
imagesc(t,fs,abs(VSST));title('VSST');
set(gca,'YDir','normal','xtick',[],'ytick',[]);
colormap(1-gray);
%pause;
%close;

% Display reconstruction
h=figure();
imagesc(t,fs,abs(SST));
set(gca,'YDir','normal');
colormap(1-gray);
xlabel('t');
ylabel('\eta');

[Cs, Es] = exridge_mult(SST, nmodes, lambda, clwin);
colridge(h,Cs);
legend('Mode 1','Mode 2', 'Mode 3');
title('Ridges extraction');

%pause;

imf = recmodes(VSST,Cs,d);
figure();
subplot(3,1,1);
plot(t,abs(imf(1,:)-s1),'b');
ylabel('Error 1');set(gca,'xtick',[]);xlim([.1 .9]);ylim([0 .4]);
subplot(3,1,2);
plot(t,abs(imf(2,:)-s2),'g');
ylabel('Error 2');set(gca,'xtick',[]);xlim([.1 .9]);ylim([0 .4]);
subplot(3,1,3);
plot(t,abs(imf(3,:)-s3),'r');
ylabel('Error 3');xlabel('t');xlim([.1 .9]);ylim([0 .4]);

disp(snr(s1(index),imf(1,index)-s1(index)));
disp(snr(s2(index),imf(2,index)-s2(index)));
disp(snr(s3(index),imf(3,index)-s3(index)));

pause;
close all;

printf_figure_multi_mode(VSST,t,fs, sigma, Ren, Sha,nmodes, lambda,clwin,sigma_optR,sigma_optS,imf,s1,s2,s3,index)

%saveas(gcf,'/kora/home/these/phamdu/Documents/sst2/matlab_SST2/figures/multimode.jpg')
end


